<template>
  <section class="login-form">
    <h2 class="text-center">Login</h2>
    <form action="" method="post">
      <div
        class="submit-error alert alert-danger"
        v-if="submitError">
        Username and/or password incorrect!
      </div>
      <div class="form-group">
        <label for="inputLogin">Username</label>
        <input
          id="inputLogin"
          v-model="login"
          type="text"
          class="form-control">
      </div>
      <div class="form-group">
        <label for="inputPassword">Password</label>
        <input
          id="inputPassword"
          v-model="password"
          type="password"
          class="form-control">
      </div>
      <nuxt-link to="/signup" class="btn btn-outline-secondary">
        Sign up
      </nuxt-link>
      <button
        :class="btnClass"
        type="submit"
        @click.prevent="submit"
        :disabled="submitting">
        Login
      </button>
    </form>
  </section>
</template>

<script>

export default {
  data() {
    return {
      submitError: false,
      submitting: false,
      btnClass: ["btn", "btn-secondary", "btn-submit", "btn-touch", "float-right"],
    };
  },
  computed: {
    login: {
      get() {
        return this.$store.state.login.login;
      },
      set(value) {
        this.$store.state.login.login = value;
      }
    },
    password: {
      get() {
        return this.$store.state.login.password;
      },
      set(value) {
        this.$store.state.login.password = value;
      }
    },

  },
  methods: {
    submit() {
      this.submitting = true;
      this.btnClass = this.btnClass.concat("btn-disabled");
      const info = {
        login: this.login,
        password: this.password,
      };

      let ins = this;
      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/login',
        data: info
      })
        .then( res => {
          ins.submitting = false;
          ins.btnClass.pop();
          ins.submitError = false;

          // store current user
          ins.$store.state.user = res.data;

          // clear form data
          ins.$store.state.login.login = '';
          ins.$store.state.login.password = '';

          // redirect
          ins.$router.push('/home');
        })
        .catch( err => {
          ins.submitting = false;
          ins.btnClass.pop();
          ins.submitError = true;

          console.log(err);
        });
    }
  },
  components: {
  }
}
</script>
